| Flutter Impeller |

Public Member Functions | List of all members
impeller::RoundRectGeometry Class Referencefinal

`#include <round_rect_geometry.h>`

Inheritance diagram for impeller::RoundRectGeometry:

## Public Member Functions
| RoundRectGeometry (const Rect &bounds, const Size &radii)
| ~RoundRectGeometry ()=default
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override
Public Member Functions inherited from impeller::Geometry
virtual GeometryResult::Mode | GetResultMode () const
virtual bool | CanApplyMaskFilter () const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::shared_ptr< Geometry > | MakeFillPath (const Path &path, std::optional< Rect > inner_rect=std::nullopt)
static std::shared_ptr< Geometry > | MakeStrokePath (const Path &path, Scalar stroke_width=0.0, Scalar miter_limit=4.0, Cap stroke_cap=Cap::kButt, Join stroke_join=Join::kMiter)
static std::shared_ptr< Geometry > | MakeCover ()
static std::shared_ptr< Geometry > | MakeRect (const Rect &rect)
static std::shared_ptr< Geometry > | MakeOval (const Rect &rect)
static std::shared_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, Scalar width, Cap cap)
static std::shared_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::shared_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::shared_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::shared_ptr< Geometry > | MakePointField (std::vector< Point > points, Scalar radius, bool round)
Static Protected Member Functions inherited from impeller::Geometry
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)
static GeometryResult | ComputePositionUVGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Matrix &uv_transform, const Entity &entity, RenderPass &pass)

## Detailed Description

Definition at line 16 of file round_rect_geometry.h.

## Constructor & Destructor Documentation

## ◆ RoundRectGeometry()

impeller::RoundRectGeometry::RoundRectGeometry | ( | const Rect & | bounds,
|  | const Size & | radii
| ) |  |
| explicit

Definition at line 9 of file round_rect_geometry.cc.

10 : bounds_(bounds), radii_(radii) {}

## ◆ ~RoundRectGeometry()

impeller::RoundRectGeometry::~RoundRectGeometry | ( |  | ) |
| default

## Member Function Documentation

## ◆ CoversArea()

bool impeller::RoundRectGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| override virtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 46 of file round_rect_geometry.cc.

47 {
48 if (!transform.IsTranslationScaleOnly()) {
49 return false;
50 }
51 bool flat_on_tb = bounds_.GetWidth() > radii_.width * 2;
52 bool flat_on_lr = bounds_.GetHeight() > radii_.height * 2;
53 if (!flat_on_tb && !flat_on_lr) {
54 return false;
55 }
56 // We either transform the bounds and delta-transform the radii,
57 // or we compute the vertical and horizontal bounds and then
58 // transform each. Either way there are 2 transform operations.
59 // We could also get a weaker answer by computing just the
60 // "inner rect" and only doing a coverage analysis on that,
61 // but this process will produce more culling results.
62 if (flat_on_tb) {
63 Rect vertical_bounds = bounds_.Expand(Size{-radii_.width, 0});
64 Rect coverage = vertical_bounds.TransformBounds(transform);
65 if (coverage.Contains(rect)) {
66 return true;
67 }
68 }
69 if (flat_on_lr) {
70 Rect horizontal_bounds = bounds_.Expand(Size{0, -radii_.height});
71 Rect coverage = horizontal_bounds.TransformBounds(transform);
72 if (coverage.Contains(rect)) {
73 return true;
74 }
75 }
76 return false;
77 }

References impeller::TRect< T >::Contains(), impeller::TRect< T >::Expand(), impeller::TRect< T >::GetHeight(), impeller::TRect< T >::GetWidth(), impeller::TSize< T >::height, impeller::Matrix::IsTranslationScaleOnly(), impeller::TRect< T >::TransformBounds(), and impeller::TSize< T >::width.

## ◆ IsAxisAlignedRect()

bool impeller::RoundRectGeometry::IsAxisAlignedRect | ( |  | ) | const
| override virtual

Reimplemented from impeller::Geometry.

Definition at line 79 of file round_rect_geometry.cc.

79 {
80 return false;
81 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/round_rect_geometry.h
- impeller/entity/geometry/round_rect_geometry.cc

impeller::TRect::TransformBounds
constexpr TRect TransformBounds(const Matrix &transform) const
Creates a new bounding box that contains this transformed rectangle.
Definition: rect.h:405
impeller::Size
TSize< Scalar > Size
Definition: size.h:137
impeller::TRect::GetHeight
constexpr Type GetHeight() const
Returns the height of the rectangle, equivalent to |GetSize().height|.
Definition: rect.h:314
impeller::TRect::GetWidth
constexpr Type GetWidth() const
Returns the width of the rectangle, equivalent to |GetSize().width|.
Definition: rect.h:308
impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:661
impeller::TSize::width
Type width
Definition: size.h:22
impeller::TSize::height
Type height
Definition: size.h:23
impeller::TRect::Expand
constexpr TRect< T > Expand(T left, T top, T right, T bottom) const
Returns a rectangle with expanded edges. Negative expansion results in shrinking.
Definition: rect.h:547